function [newpath] = pathsmoothing(input_path,Rmin)
%This function smoothes unsmoothed lines by taking into account required
%minimum radius of curvature to prevent slipping of flowlines during
%installation. Path data and Rmin should be added as an input
x=input_path(:,1);
y=input_path(:,2);
z=input_path(:,3);
% The first interpolation by using cubic spline method 
num = numel(x) ;
L = zeros(num,1) ;
for i=2:num     
    arc_length = sqrt((x(i)-x(i-1))^2+(y(i)-y(i-1))^2+(z(i)-z(i-1))^2);     
    L(i) = L(i-1) + arc_length; 
end
L=L./L(num);
x_t = spline(L,x) ;
y_t = spline(L,y) ;
z_t = spline(L,z) ;
tt = linspace(0,1,500) ;
xi = ppval(x_t,tt) ;
yi = ppval(y_t,tt) ;
zi = ppval(z_t,tt) ;
LinePath1=[transpose(xi), transpose(yi), transpose(zi)];
LinePathCal1=[transpose(xi), transpose(yi)];
LinePath2=LinePath1;
LinePathCal2=LinePathCal1;
num_removingpoints=1;
check=1;
%Iterative process for determining smoothed route with required minimum
%allowable Rmin
while check>0
    check=0;
while num_removingpoints>0
    [m,c]=size(LinePathCal1);
    num_pathpoints=m;
    removingpoints=[];
for i=1:m-2
    R=radiusofcurvature(LinePathCal1(i,:),LinePathCal1(i+1,:),LinePathCal1(i+2,:));
        %Writtenn function for calculating radius of curvature for three
        %points
    if R<Rmin
        removingpoints=[removingpoints, i+1];
    end
end
LinePathCal1(removingpoints,:)=[];
LinePath1(removingpoints,:)=[];
num_removingpoints=numel(removingpoints);
end
[m1 n1]=size(LinePath1);
[m2 n2]=size(LinePath2);
if m1~=m2
    check=1;
    num = m1 ;
    L = zeros(num,1) ;
for i=2:num     
    arc_length = sqrt((LinePath1(i,1)-LinePath1(i-1,1))^2+(LinePath1(i,2)-LinePath1(i-1,2))^2+(LinePath1(i,3)-LinePath1(i-1,3))^2);     
    L(i) = L(i-1) + arc_length; 
end
L=L./L(num);
x_t = spline(L,LinePath1(:,1)) ;
y_t = spline(L,LinePath1(:,2)) ;
z_t = spline(L,LinePath1(:,3)) ;
tt = linspace(0,1,500) ;
xinew = ppval(x_t,tt) ;
yinew = ppval(y_t,tt) ;
zinew = ppval(z_t,tt) ;
LinePath1=[transpose(xinew), transpose(yinew), transpose(zinew)];
LinePathCal1=[transpose(xinew), transpose(yinew)];
LinePath2=LinePath1;
LinePathCal2=LinePathCal1;
end
end
[newpath]=LinePath1;
end

