function [Radius] = radiusofcurvature(v1,v2,v3)
% Calculation of radius of curvature
%  v1,v2,v3 are 2D coordinates of the three neighbouring points in the
%  route
MPv1v2= (v2+v1)/2;
gradv1v2=(v1(2)-v2(2))/(v1(1)-v2(1));
perpgradv1v2=-1/gradv1v2;
MPv2v3= (v3+v2)/2;
gradv2v3=(v2(2)-v3(2))/(v2(1)-v3(1));
perpgradv2v3=-1/gradv2v3;
MPv1v3= (v3+v1)/2;
gradv1v3=(v1(2)-v3(2))/(v1(1)-v3(1));
perpgradv1v3=-1/gradv1v3;
CP=zeros(1,2);
if perpgradv1v2==perpgradv2v3
    R=1/0;
    elseif gradv1v2==0
        CP(1)=(perpgradv1v3*MPv1v3(1)-MPv1v3(2)-perpgradv2v3*MPv2v3(1)+MPv2v3(2))/(perpgradv1v3-perpgradv2v3);
        CP(2)=perpgradv1v3*CP(1)-perpgradv1v3*MPv1v3(1)+MPv1v3(2);
        R=sqrt((v3(1)-CP(1))^2+(v3(2)-CP(2))^2);
    elseif gradv2v3==0
        CP(1)=(perpgradv1v2*MPv1v2(1)-MPv1v2(2)-perpgradv1v3*MPv1v3(1)+MPv1v3(2))/(perpgradv1v2-perpgradv1v3);
        CP(2)=perpgradv1v2*CP(1)-perpgradv1v2*MPv1v2(1)+MPv1v2(2);
        R=sqrt((v3(1)-CP(1))^2+(v3(2)-CP(2))^2);
    else
        CP(1)=(perpgradv1v2*MPv1v2(1)-MPv1v2(2)-perpgradv2v3*MPv2v3(1)+MPv2v3(2))/(perpgradv1v2-perpgradv2v3);
        CP(2)=perpgradv1v2*CP(1)-perpgradv1v2*MPv1v2(1)+MPv1v2(2);
        R=sqrt((v3(1)-CP(1))^2+(v3(2)-CP(2))^2);
end
[Radius]=R;
end